Imports System.Net
Imports System.Net.Mail
Imports System.Net.Mail.SmtpClient

Public Class classEMail
    '// EMail (from,to,body,cc) 
    Private Message As MailMessage = New MailMessage()
    '// Anlage
    Private Attach As Attachment
    '// Authenticated
    Private SmtpUser As New NetworkCredential()
    '// Versenden ber SMTPClient
    Private Smtp As New SmtpClient()
 
    Public Sub New()

    End Sub

    '// Absender
    Public Function Absender(ByVal Address As String, ByVal DisplayName As String) As String
        Message.From = New MailAddress(Address, DisplayName)
        Return Address & " (" & DisplayName & ")"
    End Function

    '// Empfnger
    Public Function Empfnger(ByVal Address As String, ByVal DisplayName As String) As String
        Message.To.Add(New MailAddress(Address, DisplayName))
        Return Address & " (" & DisplayName & ")"
    End Function

    '// Weitere Empfnger Als Array
    'Public Function WeitereEmpfnger(ByVal Addresses() As String) As String
    '    Dim Retval As String = ""

    '    For iIndex As Integer = 0 To Addresses.GetUpperBound(0)
    '        Message.CC.Add(Addresses(iIndex))
    '        Retval &= Addresses(iIndex) & "; "
    '    Next

    '    If Retval.EndsWith("; ") Then
    '        Retval = Retval.Substring(0, Retval.Length - 2)
    '    End If

    '    Return Retval
    'End Function

    '// Weitere Empfnger Einzeln eingeben
    Public Function WeitereEmpfnger(ByVal Addresses As String) As String
        Dim sText As String = ""

        Message.CC.Add(Addresses)

        For iIndex As Integer = 0 To Message.CC.Count - 1
            sText &= Message.CC(iIndex).Address & "; "
        Next

        If sText.EndsWith("; ") Then
            sText = sText.Substring(0, sText.Length - 2)
        End If

        Return sText
    End Function

    '// Betreff & Nachricht
    Public Function Nachricht(ByVal Betreff As String, ByVal Text As String) As MailMessage
        Message.Subject = Betreff
        Message.Body = Text

        Return Message
    End Function

    '// Einstellungen der Nachricht (Als HTML oder nicht & Prioritt der Nachricht)
    Public Function Nachricht_Einstellungen(ByVal IsTextHTML As Boolean, ByVal Prioritt As MailPriority) As MailMessage
        Message.IsBodyHtml = IsTextHTML
        Message.Priority = Prioritt

        Return Message
    End Function

    '// Anlage als Array
    'Public Sub Anlage(ByVal Pfad() As String)
    '    For iIndex As Integer = 0 To Pfad.GetUpperBound(0)
    '        Attach = New System.Net.Mail.Attachment(Pfad(iIndex))

    '        Message.Attachments.Add(Attach)
    '    Next
    'End Sub

    '// Anlage Einzeln
    Public Sub Anlage(ByVal Pfad As String)
        Attach = New System.Net.Mail.Attachment(Pfad)
        Message.Attachments.Add(Attach)
    End Sub

    '// Getestet
    Public Function Senden_MitAuthenzierung(ByVal Kontoname As String, ByVal Password As String, ByVal SmtpAddress As String) As Boolean
        '// Authenzierung
        SmtpUser.UserName = Kontoname
        SmtpUser.Password = Password

        '-- Send Message
        Smtp.UseDefaultCredentials = False
        Smtp.Credentials = SmtpUser
        Smtp.Host = SmtpAddress
        Smtp.DeliveryMethod = SmtpDeliveryMethod.Network

        Try
            Smtp.Send(Message)
            Return True
        Catch ex As Exception
            MessageBox.Show(ex.Message, ex.Source)
            Return False
        End Try
    End Function
End Class
